//******************************************************************************
//* MiniCISC CPU                                                               *
//*                                                                            *
//* Control signal value definitions.                                          *
//******************************************************************************

//******************************************************************************
//* ALU operand 2 select.                                                      *
//******************************************************************************
localparam ALU_OP2_MEM  = 1'b0;        //Memory
localparam ALU_OP2_CNST = 1'b1;        //Constant 1


//******************************************************************************
//* ALU operation types.                                                       *
//******************************************************************************
localparam ALU_OP_MOVE  = 2'b00;       //Register move
localparam ALU_OP_ARITH = 2'b01;       //Arithmetic (addition, subtraction)
localparam ALU_OP_LOGIC = 2'b10;       //Logic (bitwise AND, OR, XOR)
localparam ALU_OP_SHIFT = 2'b11;       //Shift


//******************************************************************************
//* ALU arithmetic operations.                                                 *
//******************************************************************************
localparam ARITH_OP_ADD = 1'b0;        //Addition
localparam ARITH_OP_SUB = 1'b1;        //Subtraction


//******************************************************************************
//* ALU logic operations.                                                      *
//******************************************************************************
localparam LOGIC_OP_AND = 2'b00;       //Bitwise AND
localparam LOGIC_OP_OR  = 2'b01;       //Bitwise OR
localparam LOGIC_OP_XOR = 2'b10;       //Bitwise XOR


//******************************************************************************
//* ALU shift operations.                                                      *
//******************************************************************************
localparam SHIFT_SHL = 2'b00;          //Shift left
localparam SHIFT_SHR = 2'b01;          //Shift right
localparam SHIFT_ROL = 2'b10;          //Rotate left
localparam SHIFT_ROR = 2'b11;          //Rotate right


//******************************************************************************
//* Memory address select.                                                     *
//******************************************************************************
localparam MEM_ADDR_PC  = 2'b00;
localparam MEM_ADDR_ABS = 2'b01;
localparam MEM_ADDR_X   = 2'b10;
localparam MEM_ADDR_Y   = 2'b11;
